Wt: Wt::WDatePicker Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WDatePicker Class Reference

A date picker. More...

`#include <Wt/WDatePicker.h>`

Inheritance diagram for Wt::WDatePicker:
[legend]

## Public Member Functions
| WDatePicker ()
| Create a new date picker.
| WDatePicker (WLineEdit *forEdit)
| Create a new date picker for a line edit.
| WDatePicker (std::unique_ptr< WInteractWidget > displayWidget, WLineEdit *forEdit)
| Create a new date picker for existing line edit and with custom display widget.
| ~WDatePicker ()
| Destructor.
virtual std::shared_ptr< WDateValidator > | dateValidator () const
| Returns the validator.
void | setFormat (const WString &format)
| Sets the format used for parsing or writing the date in the line edit.
const WString & | format () const
| Returns the format.
WCalendar * | calendar () const
| The calendar widget.
WLineEdit * | lineEdit () const
| The line edit.
WInteractWidget * | displayWidget () const
| The display widget.
WPopupWidget * | popupWidget () const
| The popup widget.
WDate | date () const
| The current date.
void | setDate (const WDate &date)
| Sets the current date.
void | setEnabled (bool enabled)
| Sets whether the widget is enabled.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hide/unhide the widget.
void | setBottom (const WDate &bottom)
| Sets the bottom of the valid date range.
WDate | bottom () const
| Returns the bottom date of the valid range.
void | setTop (const WDate &top)
| Sets the top of the valid date range.
WDate | top () const
| Returns the top date of the valid range.
Signal & | changed ()
| Signal emitted when the value has changed.
void | setPopupVisible (bool visible)
| Shows or hides the popup.
Signal & | popupClosed ()
| A signal which indicates that the popup has been closed.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A date picker.

A date picker shows a line edit and an icon which when clicked popups a WCalendar for editing the date. Any date entered in the line edit is reflected in the calendar, and vice-versa.

Each of these widgets may be accessed individually (lineEdit(), calendar(), and displayWidget()) and there is a constructor that allows you to specify an existing line edit and display widget.

The date format used by default is `"dd/MM/yyyy"` and can be changed using setFormat(). At any time, the date set may be read using date(), or can be changed using setDate().

Usage example:

Wt::WDatePicker *picker = addWidget(std::make_unique<Wt::WDatePicker>());
picker->setFormat("dd-MM-yyyy");
picker->setDate(Wt::WDate(1976, 6, 14));
Wt::WDatePicker
A date picker.
Definition WDatePicker.h:54
Wt::WDatePicker::setFormat
void setFormat(const WString &format)
Sets the format used for parsing or writing the date in the line edit.
Wt::WDatePicker::setDate
void setDate(const WDate &date)
Sets the current date.
Wt::WDate
A value class that represents a date on the Gregorian calendar.
Definition WDate.h:62

### i18n

Internationalization of WDatePicker is mostly handled through the internationalization mechanism of WDate.

Deprecated
  The date picker is deprecated in favor of WDateEdit

## Constructor & Destructor Documentation

## ◆ WDatePicker() [1/3]

Wt::WDatePicker::WDatePicker | ( |  | ) |

Create a new date picker.

This constructor creates a line edit with an icon that leads to a popup calendar. A WDateValidator is configured for the line edit.

## ◆ WDatePicker() [2/3]

Wt::WDatePicker::WDatePicker | ( | WLineEdit * | forEdit | ) |

Create a new date picker for a line edit.

This constructor creates an icon that leads to a popup calendar.

The `forEdit` argument is the lineEdit that works in conjunction with the date picker. This widget does not become part of the date picker, and may be located anywhere else.

## ◆ WDatePicker() [3/3]

Wt::WDatePicker::WDatePicker | ( | std::unique_ptr< WInteractWidget > | displayWidget,
|  | WLineEdit * | forEdit )

Create a new date picker for existing line edit and with custom display widget.

The `displayWidget` is a button or image which much be clicked to open the date picker.

The `forEdit` argument is the lineEdit that works in conjunction with the date picker.

## Member Function Documentation

## ◆ calendar()

WCalendar * Wt::WDatePicker::calendar | ( |  | ) | const

The calendar widget.

Returns the calendar widget.

## ◆ changed()

Signal & Wt::WDatePicker::changed | ( |  | ) |

Signal emitted when the value has changed.

This signal is emitted when a new date has been entered (either through the line edit, or through the calendar popup).

## ◆ date()

WDate Wt::WDatePicker::date | ( |  | ) | const

The current date.

Reads the current date from the lineEdit().

Returns an invalid date (for which WDate::isValid() returns `false`) if the date could not be parsed using the current format().

See also
  setDate(), WDate::fromString(), WLineEdit::text()

## ◆ dateValidator()

virtual std::shared_ptr< WDateValidator > Wt::WDatePicker::dateValidator | ( |  | ) | const
| virtual

Returns the validator.

Most of the configuration of the date edit is stored in the validator.

## ◆ displayWidget()

WInteractWidget * Wt::WDatePicker::displayWidget | ( |  | ) | const

The display widget.

Returns the icon which activates the popup.

## ◆ format()

const WString & Wt::WDatePicker::format | ( |  | ) | const

Returns the format.

See also
  setFormat()

## ◆ lineEdit()

WLineEdit * Wt::WDatePicker::lineEdit | ( |  | ) | const

The line edit.

Returns the line edit which works in conjunction with this date picker.

## ◆ popupClosed()

Signal & Wt::WDatePicker::popupClosed | ( |  | ) |

A signal which indicates that the popup has been closed.

The signal is only fired when the popup has been closed by the user.

## ◆ popupWidget()

WPopupWidget * Wt::WDatePicker::popupWidget | ( |  | ) | const

The popup widget.

Returns the popup widget that contains the calendar.

## ◆ render()

virtual void Wt::WDatePicker::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WCompositeWidget.

## ◆ setDate()

void Wt::WDatePicker::setDate | ( | const WDate & | date | ) |

Sets the current date.

Does nothing if the current date is `Null`.

See also
  date()

## ◆ setDisabled()

virtual void Wt::WDatePicker::setDisabled | ( | bool | disabled | ) |
| overridevirtual

Sets whether the widget is disabled.

Enables or disables the widget (including all its descendant widgets). setDisabled(false) will enable this widget and all descendant widgets that are not disabled. A widget is only enabled if it and all its ancestors in the widget tree are disabled.

Typically, a disabled form widget will not allow changing the value, and disabled widgets will not react to mouse click events.

Note
  enable() and disable() are considered to be stateless slots by default. If you override setDisabled() and need to modify server state whenever it is called, you'll need to call WObject::isNotStateless().

See also
  disable(), enable()

Reimplemented from Wt::WCompositeWidget.

## ◆ setEnabled()

void Wt::WDatePicker::setEnabled | ( | bool | enabled | ) |

Sets whether the widget is enabled.

This is the oppositie of setDisabled().

## ◆ setFormat()

void Wt::WDatePicker::setFormat | ( | const WString & | format | ) |

Sets the format used for parsing or writing the date in the line edit.

Sets the format used for representing the date in the line edit. If the line edit has a WDateValidator configured for it, then also there the format is updated.

The default format is `'dd/MM/yyyy'`.

See also
  format(), WDate::toString()